



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>图片人脸检测——OpenCV版（二）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">图片人脸检测——OpenCV版（二）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 02:21:29 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>图片人脸检测</h1>
<p>人脸检测使用到的技术是OpenCV，上一节已经介绍了OpenCV的环境安装，<a href="http://www.cnblogs.com/vipstone/p/8884956.html" rel="external nofollow noreferrer">点击查看</a>.</p>
<h3>往期目录</h3>
<p><a href="http://www.cnblogs.com/vipstone/p/9026767.html" rel="external nofollow noreferrer">视频人脸检测&mdash;&mdash;Dlib版（六）</a><br /><a href="http://www.cnblogs.com/vipstone/p/8998249.html" rel="external nofollow noreferrer">OpenCV添加中文（五）</a><br /><a href="http://www.cnblogs.com/vipstone/p/8964656.html" rel="external nofollow noreferrer">图片人脸检测&mdash;&mdash;Dlib版（四）</a><br /><a href="http://www.cnblogs.com/vipstone/p/8933916.html" rel="external nofollow noreferrer">视频人脸检测&mdash;&mdash;OpenCV版（三）</a><br /><a href="http://www.cnblogs.com/vipstone/p/8884991.html" rel="external nofollow noreferrer">图片人脸检测&mdash;&mdash;OpenCV版（二）</a><br /><a href="http://www.cnblogs.com/vipstone/p/8884956.html" rel="external nofollow noreferrer">OpenCV环境搭建（一）</a><br />更多更新，欢迎访问我的github：<a href="https://github.com/vipstone/faceai" rel="external nofollow noreferrer">https://github.com/vipstone/faceai</a></p>
<h2>功能展示</h2>
<p>识别一种图上的所有人的脸，并且标出人脸的位置，画出人眼以及嘴的位置，展示效果图如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/172074/201804/172074-20180419182335702-1100138980.png" /></p>
<p>多张脸识别效果图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/172074/201804/172074-20180419182349931-1220374755.png" /></p>
<h2>技术实现思路</h2>
<p>图片转换成灰色（去除色彩干扰，让图片识别更准确）</p>
<p>图片上画矩形</p>
<p>使用训练分类器查找人脸</p>
<h2>具体实现代码</h2>
<p><strong>图片转换成灰色</strong></p>
<p>使用OpenCV的cvtColor()转换图片颜色，代码如下：</p>
<div>
<pre class="prettyprint linenums">import cv2

filepath = "img/xingye-1.jpg"<br />
img = cv2.imread(filepath)<br />
# 转换灰色<br />
gray = cv2.cvtColor(img, cv2.COLOR_BGR2GRAY)<br />
# 显示图像<br />
cv2.imshow("Image", gray)<br />
cv2.waitKey(0)<br />
cv2.destroyAllWindows()</pre>
</div>
<p><strong>图片上画矩形</strong></p>
<p>使用OpenCV的rectangle()绘制矩形，代码如下：</p>
<div>
<pre class="prettyprint linenums">import cv2

filepath = "img/xingye-1.jpg"<br />
img = cv2.imread(filepath)  # 读取图片<br />
gray = cv2.cvtColor(img, cv2.COLOR_BGR2GRAY)  # 转换灰色<br />
x = y = 10  # 坐标<br />
w = 100  # 矩形大小（宽、高）<br />
color = (0, 0, 255)  # 定义绘制颜色<br />
cv2.rectangle(img, (x, y), (x + w, y + w), color, 1)  # 绘制矩形<br />
cv2.imshow("Image", img)  # 显示图像<br />
cv2.waitKey(0)<br />
cv2.destroyAllWindows()  # 释放所有的窗体资源</pre>
</div>
<p><strong>使用训练分类器查找人脸</strong></p>
<p>在使用OpenCV的人脸检测之前，需要一个人脸训练模型，格式是xml的，我们这里使用OpenCV提供好的人脸分类模型xml，下载地址：<a href="https://github.com/opencv/opencv/tree/master/data/haarcascades" rel="external nofollow noreferrer">https://github.com/opencv/opencv/tree/master/data/haarcascades</a>&nbsp;可全部下载到本地，本人存放的路径是：C:\Python36\Lib\site-packages\opencv-master\data\haarcascades.</p>
<p>完整实现代码：</p>
<div>
<pre class="prettyprint linenums">import cv2

filepath = "img/xingye-1.jpg"<br />
img = cv2.imread(filepath)  # 读取图片<br />
gray = cv2.cvtColor(img, cv2.COLOR_BGR2GRAY)  # 转换灰色

# OpenCV人脸识别分类器<br />
classifier = cv2.CascadeClassifier(<br />
    "C:\Python36\Lib\site-packages\opencv-master\data\haarcascades\haarcascade_frontalface_default.xml"<br />
)<br />
color = (0, 255, 0)  # 定义绘制颜色<br />
# 调用识别人脸<br />
faceRects = classifier.detectMultiScale(<br />
    gray, scaleFactor=1.2, minNeighbors=3, minSize=(32, 32))<br />
if len(faceRects):  # 大于0则检测到人脸<br />
    for faceRect in faceRects:  # 单独框出每一张人脸<br />
        x, y, w, h = faceRect<br />
        # 框出人脸<br />
        cv2.rectangle(img, (x, y), (x + h, y + w), color, 2)<br />
        # 左眼<br />
        cv2.circle(img, (x + w // 4, y + h // 4 + 30), min(w // 8, h // 8),<br />
                   color)<br />
        #右眼<br />
        cv2.circle(img, (x + 3 * w // 4, y + h // 4 + 30), min(w // 8, h // 8),<br />
                   color)<br />
        #嘴巴<br />
        cv2.rectangle(img, (x + 3 * w // 8, y + 3 * h // 4),<br />
                      (x + 5 * w // 8, y + 7 * h // 8), color)

cv2.imshow("image", img)  # 显示图像<br />
c = cv2.waitKey(10)

cv2.waitKey(0)<br />
cv2.destroyAllWindows()
</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4953wpv8.html">ORACLE 12C新特性&mdash;&mdash;CDB与PDB</a>
		</li>
						<li><a href="https://www.batexi.com/a/390dvgj8.html">mysql-5&period;7日志设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mmnv1q.html">认识Service</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnykzpq.html">Swing圆角边框的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y3knnq.html">Hibernate数据库持久层框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y666nq.html">Jquery中Ajax异步请求中的async参数的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w4gpwq.html">Vim的设置和使用&mdash;&mdash;编程者</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mkzoxq.html">python中os模块常用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyx24x9.html">Asp&period;net常用开发方法之DataTable&sol;DataReader转Json格式代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m04yo8.html">bzoj千题计划177：bzoj1858&colon; &lbrack;Scoi2010&rsqb;序列操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zon61xq.html">break和continue的简单介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjdgme9.html">python垃圾回收机制&colon;引用计数 VS js垃圾回收机制&colon;标记清除</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2rkn0q.html">ES6 proxy&lpar;代理拦截&rpar; &amp;amp&semi;&amp;amp&semi;Reflect</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r0o128.html">100-days&colon; Six</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjpr5xq.html">Orchard之Module升级</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vjwl6q.html">magento优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp34649.html">VideoView的全屏问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vodg2q.html">js 离开页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p1zw0q.html">HDU 1103 Flo&apos;s Restaurant&lpar;模拟&plus;优先队列&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kogrn5q.html">OpenCL 图像卷积 1</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8o1llk5q.html">杨其菊201771010134《面向对象程序设计Java》第二周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllppw1q.html">Eclipse Python 开发环境搭建 pydev 插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv44gy8.html">leveldb 学习记录&lpar;二&rpar; Slice</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv44238.html">cpp 区块链模拟示例&lpar;六&rpar; 交易</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy00zmq.html">c&plus;&plus; 计算cpu占用率</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjrx349.html">java多线程系列8 高级同步工具&lpar;2&rpar;CountDownLatch</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw2y4d8.html">CUDA&lbrack;4&rsqb; sample program&colon; matrix-vector multiplication</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4rk1m9.html">C程序编程规范一</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv4yj38.html">深入理解linux关闭文件和删除文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4rgoj9.html">你应该这么理解TCP的三次握手和四次挥手</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
